////////////////////////////////////////////////////////////////////////////////
//
// @copyright COSEDA Technologies GmbH. All rights reserved.
//            (customizable in sca_modules.dtd)
//
////////////////////////////////////////////////////////////////////////////////
//
// @project      pll
//
// @library      libpll
//
// @file         counter
//
// @brief
//      /** Frequency divider implementation */
//
// DESCRIPTION OF PORTS:
// clk of type bool
//       /** Input clock */
// out of type bool
//       /** Output */
//
// DESCRIPTION OF PARAMETERS:
// n of type long
//       /** Number of cycles to count */
//
// this file was generated by 'sca_xml2h.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
//  Version Id       : $Id$
//  @author          : Amrico Dias
//  Last Modified By : $Author$
//  Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

#ifndef PLL_LIBPLL_COUNTER_H_
#define PLL_LIBPLL_COUNTER_H_

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE primitive.
 *  = (do changes only via the module editor!)
 *  ============================================================================
 */

#include <systemc>


namespace pll_namespace
{

SC_MODULE(counter)
{
    /// sc ports
    sc_core::sc_in<bool  > clk; /** Input clock */
    sc_core::sc_out<bool  > out; /** Output */

    /// parameters
    struct params
    {
        long  n; /** Number of cycles to count */

        params()
        {
            n = 1;
        }
    } p;

    void process();



    SC_HAS_PROCESS(counter);

    /// constructor
    counter(sc_core::sc_module_name, const params& pa = params() ) : clk("clk"),
                                                       out("out"),
                                                       p(pa),
                                                       s(this->create_states())
    {

        SC_METHOD(process);
        sensitive << clk.pos();


        this->construct();

    }

    /// destructor
    virtual ~counter();


    /// states
    struct states;
    states& s;
    states* operator -> () { return &s; }

    private:
        static states& create_states();
        void construct();

};



} // end namespace pll_namespace
using namespace pll_namespace;

#endif // PLL_LIBPLL_COUNTER_H_

#ifdef ACCESS_MODULE_STATE_DECLARATION
#ifndef PLL_LIBPLL_COUNTER_CPP_
#define PLL_LIBPLL_COUNTER_CPP_
#include "counter.cpp"
#endif
#endif
