/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.
///            (customizable in sca_modules.dtd)
///
/////////////////////////////////////////////////////////////////////////////////
//
// @project      pll
//
// @library      libpll
//
// @file         cp
//
// @brief
//      /** Charge pump implementation */
//
// DESCRIPTION OF PORTS:
// vcp of type double
//       /** input of the charge pump voltage (to limit the current) */
// icp of type double
//       /** output control current */
// up of type bool
//       /** up input */
// dn of type bool
//       /** down input */
//
// DESCRIPTION OF PARAMETERS:
// ts of type double
//       /** Time step */
// vdd of type double
//       /** Supply voltage */
// current_up of type double
//       /** Source current */
// current_dn of type double
//       /** Sink current */
// current_leak of type double
//       /** Leak current */
// mosfet_vth of type double
//       /** Mosfet threshold */
//
// this file was generated by 'sca_xml2h.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
//  Version Id       : $Id$
//  Last Modified By : $Author$
//  Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

#ifndef PLL_LIBPLL_CP_H_
#define PLL_LIBPLL_CP_H_

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE primitive.
 *  = (do changes only via the module editor!)
 *  ============================================================================
 */

// 29_BEGIN_USER_CODE
// you can add own code here.
// END_USER_CODE_29

#include <systemc-ams>

// user specified includes
#include <cmath>

// 30_BEGIN_USER_CODE
// you can add own code here.
// END_USER_CODE_30


namespace pll_namespace
{

// 31_BEGIN_USER_CODE
// you can add own code here.
// END_USER_CODE_31

SCA_TDF_MODULE(cp)
{
    // 32_BEGIN_USER_CODE
    // you can add own code here.
    // END_USER_CODE_32

    /// sca tdf ports
    sca_tdf::sc_in<bool  > up; /** up input */
    sca_tdf::sc_in<bool  > dn; /** down input */
    sca_tdf::sca_in<double  > vcp; /** input of the charge pump voltage (to limit the current) */
    sca_tdf::sca_out<double  > icp; /** output control current */

    /// parameters
    const struct params
    {
        // 34_BEGIN_USER_CODE
        // you can add own code here.
        // END_USER_CODE_34
        double ts; /** Time step */
        double vdd; /** Supply voltage */
        double current_up; /** Source current */
        double current_dn; /** Sink current */
        double current_leak; /** Leak current */
        double mosfet_vth; /** Mosfet threshold */

        params()
        {
            // 35_BEGIN_USER_CODE
            // you can add own code here.
            // END_USER_CODE_35
        }
    } p;


    /// methods
    /**
     * SystemC AMS processing callback see LRM
     */
    void processing() override;

    /**
     * SystemC AMS set_attributes callback see LRM
     */
    void set_attributes() override
    {
        this->set_attributes_cpp();
    }

    /// constructor
    cp(sc_core::sc_module_name, const params& pa = params() ) : up("up"),
                                                       dn("dn"),
                                                       vcp("vcp"),
                                                       icp("icp"),
                                                       p(pa),
                                                       s(this->create_states(pa))
    {


        this->construct();

    }

    /// destructor
    virtual ~cp();


    /// states
    struct states;
    states& s;
    states* operator -> () { return &s; }

    private:
        static states& create_states(const params& pa);
        void construct();
        void set_attributes_cpp();

        // 37_BEGIN_USER_CODE
        // you can add own code here.
        // END_USER_CODE_37

};


// 38_BEGIN_USER_CODE
// you can add own code here.
// END_USER_CODE_38

} // end namespace pll_namespace
using pll_namespace::cp;

#endif // PLL_LIBPLL_CP_H_

#ifdef ACCESS_MODULE_STATE_DECLARATION
#ifndef PLL_LIBPLL_CP_CPP_
#define PLL_LIBPLL_CP_CPP_
#include "cp.cpp"
#endif
#endif
