/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "div.scaml")
 *  ============================================================================
 */

/// include submodules
#include <sca_basic_libraries/logic_tdf/cmp_gt_eq_tdf.h>
#include <sca_basic_libraries/sources_tdf/const_src_tdf.h>
#include <sca_basic_libraries/converters/conv_tdf2de.h>
#include "counter.h"


#ifndef PLL_LIBPLL_DIV_H_
/// if this file is not included by the header keep implementation
#include "div.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct div::components
{

    /// declare instance references for external access
    cmp_gt_eq_tdf<double, bool>& i_cmp_gt_eq_tdf;	/** CMP GTEQUAL */
    const_src_tdf<double>& i_const_src_tdf;	/** constant source */
    conv_tdf2de<bool, bool>& i_conv_tdf2de;	/** converts tdf to sc */
    counter& i_counter;	/** Frequency divider implementation */

    /// declare node and signal references for external access
    sc_core::sc_signal<bool	 >& clk_de;
    sca_tdf::sca_signal<bool	 >& clk_tdf;
    sca_tdf::sca_signal<double	 >& vcm_const;

    /// component constructor
    components(
                  cmp_gt_eq_tdf<double, bool>* i_cmp_gt_eq_tdf_,
                  const_src_tdf<double>* i_const_src_tdf_,
                  conv_tdf2de<bool, bool>* i_conv_tdf2de_,
                  counter* i_counter_,
                  sc_core::sc_signal<bool	 >& clk_de_,
                  sca_tdf::sca_signal<bool	 >& clk_tdf_,
                  sca_tdf::sca_signal<double	 >& vcm_const_
               ) :
                  i_cmp_gt_eq_tdf(*i_cmp_gt_eq_tdf_),
                  i_const_src_tdf(*i_const_src_tdf_),
                  i_conv_tdf2de(*i_conv_tdf2de_),
                  i_counter(*i_counter_),
                  clk_de(clk_de_),
                  clk_tdf(clk_tdf_),
                  vcm_const(vcm_const_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_cmp_gt_eq_tdf;
        delete &i_const_src_tdf;
        delete &i_conv_tdf2de;
        delete &i_counter;

        /// delete signals
        delete &clk_de;
        delete &clk_tdf;
        delete &vcm_const;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void div::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sc_core::sc_signal<bool	 >& clk_de(* new sc_core::sc_signal<bool	 >("clk_de"));
    sca_tdf::sca_signal<bool	 >& clk_tdf(* new sca_tdf::sca_signal<bool	 >("clk_tdf"));
    sca_tdf::sca_signal<double	 >& vcm_const(* new sca_tdf::sca_signal<double	 >("vcm_const"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    cmp_gt_eq_tdf<double, bool> *i_cmp_gt_eq_tdf;
    i_cmp_gt_eq_tdf = new cmp_gt_eq_tdf<double, bool>("i_cmp_gt_eq_tdf");

    // port binding see netlist section

    const_src_tdf<double>::params p_i_const_src_tdf;
    p_i_const_src_tdf.const_val = p.vcm;
    p_i_const_src_tdf.sampling_time = sc_core::SC_ZERO_TIME;
    const_src_tdf<double> *i_const_src_tdf;
    i_const_src_tdf = new const_src_tdf<double>("i_const_src_tdf", p_i_const_src_tdf);
    // port binding see netlist section

    conv_tdf2de<bool, bool>::params p_i_conv_tdf2de;
    p_i_conv_tdf2de.initial_value = bool{};
    conv_tdf2de<bool, bool> *i_conv_tdf2de;
    i_conv_tdf2de = new conv_tdf2de<bool, bool>("i_conv_tdf2de", p_i_conv_tdf2de);
    // port binding see netlist section

    counter::params p_i_counter;
    p_i_counter.n = p.n;
    counter *i_counter;
    i_counter = new counter("i_counter", p_i_counter);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_cmp_gt_eq_tdf (cmp_gt_eq_tdf<double, bool>)
    i_cmp_gt_eq_tdf -> tdf0_i(fin);
    i_cmp_gt_eq_tdf -> tdf1_i(vcm_const);
    i_cmp_gt_eq_tdf -> tdf_o(clk_tdf);

    // i_const_src_tdf (const_src_tdf<double>)
    i_const_src_tdf -> tdf_o(vcm_const);

    // i_conv_tdf2de (conv_tdf2de<bool, bool>)
    i_conv_tdf2de -> sc_o(clk_de);
    i_conv_tdf2de -> tdf_i(clk_tdf);

    // i_counter (counter)
    i_counter -> clk(clk_de);
    i_counter -> out(fout);




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_cmp_gt_eq_tdf,
                         i_const_src_tdf,
                         i_conv_tdf2de,
                         i_counter,
                         clk_de,
                         clk_tdf,
                         vcm_const
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
div::div(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          fin("fin"),
          fout("fout"),
          p(pa)
{

    architecture();
}

/// destructor implementation
div::~div()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


