/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "div_tb.scaml")
 *  ============================================================================
 */

/// include submodules
#include "div.h"
#include <sca_basic_libraries/sources_tdf/sin_src_tdf.h>


#ifndef PLL_LIBPLL_DIV_TB_H_
/// if this file is not included by the header keep implementation
#include "div_tb.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct div_tb::components
{

    /// declare instance references for external access
    div& i_div;	/** Frequency divider */
    sin_src_tdf<double>& i_sin_src_tdf;	/** sinusoidal source */

    /// declare node and signal references for external access
    sca_tdf::sca_signal<double	 >& fin;
    sc_core::sc_signal<bool	 >& fout;

    /// component constructor
    components(
                  div* i_div_,
                  sin_src_tdf<double>* i_sin_src_tdf_,
                  sca_tdf::sca_signal<double	 >& fin_,
                  sc_core::sc_signal<bool	 >& fout_
               ) :
                  i_div(*i_div_),
                  i_sin_src_tdf(*i_sin_src_tdf_),
                  fin(fin_),
                  fout(fout_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_div;
        delete &i_sin_src_tdf;

        /// delete signals
        delete &fin;
        delete &fout;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void div_tb::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sca_tdf::sca_signal<double	 >& fin(* new sca_tdf::sca_signal<double	 >("fin"));
    sc_core::sc_signal<bool	 >& fout(* new sc_core::sc_signal<bool	 >("fout"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    div::params p_i_div;
    p_i_div.n = p.n;
    p_i_div.vcm = p.vcm;
    div *i_div;
    i_div = new div("i_div", p_i_div);
    // port binding see netlist section

    sin_src_tdf<double>::params p_i_sin_src_tdf;
    p_i_sin_src_tdf.ampl = p.vcm;
    p_i_sin_src_tdf.freq = p.fin;
    p_i_sin_src_tdf.offset = p.vcm;
    p_i_sin_src_tdf.phase = 0.0;
    p_i_sin_src_tdf.delay = sc_core::SC_ZERO_TIME;
    p_i_sin_src_tdf.delta = 0.0;
    p_i_sin_src_tdf.ac_ampl = 1.0;
    p_i_sin_src_tdf.ac_phase = 0.0;
    p_i_sin_src_tdf.sampling_time = sca_time(100e-6, SC_SEC);
    sin_src_tdf<double> *i_sin_src_tdf;
    i_sin_src_tdf = new sin_src_tdf<double>("i_sin_src_tdf", p_i_sin_src_tdf);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_div (div)
    i_div -> fin(fin);
    i_div -> fout(fout);

    // i_sin_src_tdf (sin_src_tdf<double>)
    i_sin_src_tdf -> tdf_o(fin);




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_div,
                         i_sin_src_tdf,
                         fin,
                         fout
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
div_tb::div_tb(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          p(pa)
{

    architecture();
}

/// destructor implementation
div_tb::~div_tb()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


