/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "lfilter.scaml")
 *  ============================================================================
 */

/// include submodules
#include <sca_basic_libraries/sources_sc/const_src_sc.h>


#ifndef PLL_LIBPLL_LFILTER_H_
/// if this file is not included by the header keep implementation
#include "lfilter.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct lfilter::components
{

    /// declare instance references for external access
    const_src_sc<bool>& i_const_src_sc;	/** constant source */
    sca_eln::sca_c& i_sca_c1;	/** Capacitor */
    sca_eln::sca_c& i_sca_c2;	/** Capacitor */
    sca_eln::sca_c& i_sca_c3;	/** Capacitor */
    sca_eln::sca_de_rswitch& i_sca_de_rswitch1;	/** Switch controlled by a discrete event SystemC signal */
    sca_eln::sca_de_rswitch& i_sca_de_rswitch2;	/** Switch controlled by a discrete event SystemC signal */
    sca_eln::sca_r& i_sca_r2;	/** Resistor */
    sca_eln::sca_r& i_sca_r3;	/** Resistor */
    sca_eln::sca_tdf_isource& i_sca_tdf_isource;	/** Current source driven by timed dataflow signal */
    sca_eln::sca_tdf_vsink& i_sca_tdf_vsink1;	/** Voltage to timed dataflow converter */
    sca_eln::sca_tdf_vsink& i_sca_tdf_vsink2;	/** Voltage to timed dataflow converter */

    /// declare node and signal references for external access
    sca_eln::sca_node& input_node;
    sc_core::sc_signal<bool	 >& order_control;
    sca_eln::sca_node& output_node;
    sca_eln::sca_node_ref& unnamedNet1_gnd;
    sca_eln::sca_node_ref& unnamedNet2_gnd;
    sca_eln::sca_node_ref& unnamedNet3_gnd;
    sca_eln::sca_node_ref& unnamedNet4_gnd;
    sca_eln::sca_node_ref& unnamedNet5_gnd;
    sca_eln::sca_node& unnamedNet6;
    sca_eln::sca_node_ref& unnamedNet7_gnd;
    sca_eln::sca_node& unnamedNet9;

    /// component constructor
    components(
                  const_src_sc<bool>* i_const_src_sc_,
                  sca_eln::sca_c* i_sca_c1_,
                  sca_eln::sca_c* i_sca_c2_,
                  sca_eln::sca_c* i_sca_c3_,
                  sca_eln::sca_de_rswitch* i_sca_de_rswitch1_,
                  sca_eln::sca_de_rswitch* i_sca_de_rswitch2_,
                  sca_eln::sca_r* i_sca_r2_,
                  sca_eln::sca_r* i_sca_r3_,
                  sca_eln::sca_tdf_isource* i_sca_tdf_isource_,
                  sca_eln::sca_tdf_vsink* i_sca_tdf_vsink1_,
                  sca_eln::sca_tdf_vsink* i_sca_tdf_vsink2_,
                  sca_eln::sca_node& input_node_,
                  sc_core::sc_signal<bool	 >& order_control_,
                  sca_eln::sca_node& output_node_,
                  sca_eln::sca_node_ref& unnamedNet1_gnd_,
                  sca_eln::sca_node_ref& unnamedNet2_gnd_,
                  sca_eln::sca_node_ref& unnamedNet3_gnd_,
                  sca_eln::sca_node_ref& unnamedNet4_gnd_,
                  sca_eln::sca_node_ref& unnamedNet5_gnd_,
                  sca_eln::sca_node& unnamedNet6_,
                  sca_eln::sca_node_ref& unnamedNet7_gnd_,
                  sca_eln::sca_node& unnamedNet9_
               ) :
                  i_const_src_sc(*i_const_src_sc_),
                  i_sca_c1(*i_sca_c1_),
                  i_sca_c2(*i_sca_c2_),
                  i_sca_c3(*i_sca_c3_),
                  i_sca_de_rswitch1(*i_sca_de_rswitch1_),
                  i_sca_de_rswitch2(*i_sca_de_rswitch2_),
                  i_sca_r2(*i_sca_r2_),
                  i_sca_r3(*i_sca_r3_),
                  i_sca_tdf_isource(*i_sca_tdf_isource_),
                  i_sca_tdf_vsink1(*i_sca_tdf_vsink1_),
                  i_sca_tdf_vsink2(*i_sca_tdf_vsink2_),
                  input_node(input_node_),
                  order_control(order_control_),
                  output_node(output_node_),
                  unnamedNet1_gnd(unnamedNet1_gnd_),
                  unnamedNet2_gnd(unnamedNet2_gnd_),
                  unnamedNet3_gnd(unnamedNet3_gnd_),
                  unnamedNet4_gnd(unnamedNet4_gnd_),
                  unnamedNet5_gnd(unnamedNet5_gnd_),
                  unnamedNet6(unnamedNet6_),
                  unnamedNet7_gnd(unnamedNet7_gnd_),
                  unnamedNet9(unnamedNet9_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_const_src_sc;
        delete &i_sca_c1;
        delete &i_sca_c2;
        delete &i_sca_c3;
        delete &i_sca_de_rswitch1;
        delete &i_sca_de_rswitch2;
        delete &i_sca_r2;
        delete &i_sca_r3;
        delete &i_sca_tdf_isource;
        delete &i_sca_tdf_vsink1;
        delete &i_sca_tdf_vsink2;

        /// delete signals
        delete &input_node;
        delete &order_control;
        delete &output_node;
        delete &unnamedNet1_gnd;
        delete &unnamedNet2_gnd;
        delete &unnamedNet3_gnd;
        delete &unnamedNet4_gnd;
        delete &unnamedNet5_gnd;
        delete &unnamedNet6;
        delete &unnamedNet7_gnd;
        delete &unnamedNet9;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void lfilter::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sca_eln::sca_node& input_node(* new sca_eln::sca_node("input_node"));
    sc_core::sc_signal<bool	 >& order_control(* new sc_core::sc_signal<bool	 >("order_control"));
    sca_eln::sca_node& output_node(* new sca_eln::sca_node("output_node"));
    sca_eln::sca_node_ref& unnamedNet1_gnd(* new sca_eln::sca_node_ref("unnamedNet1_gnd"));
    sca_eln::sca_node_ref& unnamedNet2_gnd(* new sca_eln::sca_node_ref("unnamedNet2_gnd"));
    sca_eln::sca_node_ref& unnamedNet3_gnd(* new sca_eln::sca_node_ref("unnamedNet3_gnd"));
    sca_eln::sca_node_ref& unnamedNet4_gnd(* new sca_eln::sca_node_ref("unnamedNet4_gnd"));
    sca_eln::sca_node_ref& unnamedNet5_gnd(* new sca_eln::sca_node_ref("unnamedNet5_gnd"));
    sca_eln::sca_node& unnamedNet6(* new sca_eln::sca_node("unnamedNet6"));
    sca_eln::sca_node_ref& unnamedNet7_gnd(* new sca_eln::sca_node_ref("unnamedNet7_gnd"));
    sca_eln::sca_node& unnamedNet9(* new sca_eln::sca_node("unnamedNet9"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    const_src_sc<bool> *i_const_src_sc;
    i_const_src_sc = new const_src_sc<bool>("i_const_src_sc", p.third_order);
    // port binding see netlist section

    sca_eln::sca_c *i_sca_c1;
    i_sca_c1 = new sca_eln::sca_c("i_sca_c1");
    i_sca_c1 -> value = p.c1;
    i_sca_c1 -> q0 = 0;

    // port binding see netlist section

    sca_eln::sca_c *i_sca_c2;
    i_sca_c2 = new sca_eln::sca_c("i_sca_c2");
    i_sca_c2 -> value = p.c2;
    i_sca_c2 -> q0 = 0.0;

    // port binding see netlist section

    sca_eln::sca_c *i_sca_c3;
    i_sca_c3 = new sca_eln::sca_c("i_sca_c3");
    i_sca_c3 -> value = p.c3;
    i_sca_c3 -> q0 = 0;

    // port binding see netlist section

    sca_eln::sca_de_rswitch *i_sca_de_rswitch1;
    i_sca_de_rswitch1 = new sca_eln::sca_de_rswitch("i_sca_de_rswitch1");
    i_sca_de_rswitch1 -> ron = 1;
    i_sca_de_rswitch1 -> roff = 100e9;
    i_sca_de_rswitch1 -> off_state = true;

    // port binding see netlist section

    sca_eln::sca_de_rswitch *i_sca_de_rswitch2;
    i_sca_de_rswitch2 = new sca_eln::sca_de_rswitch("i_sca_de_rswitch2");
    i_sca_de_rswitch2 -> ron = 1;
    i_sca_de_rswitch2 -> roff = 100e9;
    i_sca_de_rswitch2 -> off_state = false;

    // port binding see netlist section

    sca_eln::sca_r *i_sca_r2;
    i_sca_r2 = new sca_eln::sca_r("i_sca_r2");
    i_sca_r2 -> value = p.r2;

    // port binding see netlist section

    sca_eln::sca_r *i_sca_r3;
    i_sca_r3 = new sca_eln::sca_r("i_sca_r3");
    i_sca_r3 -> value = p.r3;

    // port binding see netlist section

    sca_eln::sca_tdf_isource *i_sca_tdf_isource;
    i_sca_tdf_isource = new sca_eln::sca_tdf_isource("i_sca_tdf_isource");
    i_sca_tdf_isource -> scale = -1;

    // port binding see netlist section

    sca_eln::sca_tdf_vsink *i_sca_tdf_vsink1;
    i_sca_tdf_vsink1 = new sca_eln::sca_tdf_vsink("i_sca_tdf_vsink1");
    i_sca_tdf_vsink1 -> scale = 1.0;

    // port binding see netlist section

    sca_eln::sca_tdf_vsink *i_sca_tdf_vsink2;
    i_sca_tdf_vsink2 = new sca_eln::sca_tdf_vsink("i_sca_tdf_vsink2");
    i_sca_tdf_vsink2 -> scale = 1.0;

    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_const_src_sc (const_src_sc<bool>)
    i_const_src_sc -> sc_o(order_control);

    // i_sca_c1 (sca_eln::sca_c)
    i_sca_c1 -> n(unnamedNet2_gnd);
    i_sca_c1 -> p(input_node);

    // i_sca_c2 (sca_eln::sca_c)
    i_sca_c2 -> n(unnamedNet3_gnd);
    i_sca_c2 -> p(unnamedNet6);

    // i_sca_c3 (sca_eln::sca_c)
    i_sca_c3 -> n(unnamedNet7_gnd);
    i_sca_c3 -> p(unnamedNet9);

    // i_sca_de_rswitch1 (sca_eln::sca_de_rswitch)
    i_sca_de_rswitch1 -> ctrl(order_control);
    i_sca_de_rswitch1 -> n(output_node);
    i_sca_de_rswitch1 -> p(input_node);

    // i_sca_de_rswitch2 (sca_eln::sca_de_rswitch)
    i_sca_de_rswitch2 -> ctrl(order_control);
    i_sca_de_rswitch2 -> n(unnamedNet9);
    i_sca_de_rswitch2 -> p(output_node);

    // i_sca_r2 (sca_eln::sca_r)
    i_sca_r2 -> n(unnamedNet6);
    i_sca_r2 -> p(input_node);

    // i_sca_r3 (sca_eln::sca_r)
    i_sca_r3 -> n(output_node);
    i_sca_r3 -> p(input_node);

    // i_sca_tdf_isource (sca_eln::sca_tdf_isource)
    i_sca_tdf_isource -> inp(icp);
    i_sca_tdf_isource -> n(unnamedNet1_gnd);
    i_sca_tdf_isource -> p(input_node);

    // i_sca_tdf_vsink1 (sca_eln::sca_tdf_vsink)
    i_sca_tdf_vsink1 -> n(unnamedNet4_gnd);
    i_sca_tdf_vsink1 -> outp(vctrl);
    i_sca_tdf_vsink1 -> p(output_node);

    // i_sca_tdf_vsink2 (sca_eln::sca_tdf_vsink)
    i_sca_tdf_vsink2 -> n(unnamedNet5_gnd);
    i_sca_tdf_vsink2 -> outp(vcp);
    i_sca_tdf_vsink2 -> p(input_node);




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_const_src_sc,
                         i_sca_c1,
                         i_sca_c2,
                         i_sca_c3,
                         i_sca_de_rswitch1,
                         i_sca_de_rswitch2,
                         i_sca_r2,
                         i_sca_r3,
                         i_sca_tdf_isource,
                         i_sca_tdf_vsink1,
                         i_sca_tdf_vsink2,
                         input_node,
                         order_control,
                         output_node,
                         unnamedNet1_gnd,
                         unnamedNet2_gnd,
                         unnamedNet3_gnd,
                         unnamedNet4_gnd,
                         unnamedNet5_gnd,
                         unnamedNet6,
                         unnamedNet7_gnd,
                         unnamedNet9
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
lfilter::lfilter(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          icp("icp"),
          vcp("vcp"),
          vctrl("vctrl"),
          p(pa)
{

    architecture();
}

/// destructor implementation
lfilter::~lfilter()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


