/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "psd.scaml")
 *  ============================================================================
 */

/// include submodules
#include <sca_basic_libraries/logic_sc/and2_reduced_sc.h>
#include <sca_basic_libraries/sources_sc/const_src_sc.h>
#include <sca_basic_libraries/logic_sc/dffrst_sc.h>


#ifndef PLL_LIBPLL_PSD_H_
/// if this file is not included by the header keep implementation
#include "psd.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct psd::components
{

    /// declare instance references for external access
    and2_reduced_sc<bool, bool>& i_and2_reduced_sc;	/** AND (reduced) */
    const_src_sc<bool>& i_const_src_sc1;	/** constant source */
    const_src_sc<bool>& i_const_src_sc2;	/** constant source */
    dffrst_sc<bool>& i_dffrst_sc1;	/** DFF with reset */
    dffrst_sc<bool>& i_dffrst_sc2;	/** DFF with reset */

    /// declare node and signal references for external access
    sc_core::sc_signal<bool	 >& reset;
    sc_core::sc_signal<bool	 >& unnamedNet1;
    sc_core::sc_signal<bool	 >& unnamedNet2;

    /// component constructor
    components(
                  and2_reduced_sc<bool, bool>* i_and2_reduced_sc_,
                  const_src_sc<bool>* i_const_src_sc1_,
                  const_src_sc<bool>* i_const_src_sc2_,
                  dffrst_sc<bool>* i_dffrst_sc1_,
                  dffrst_sc<bool>* i_dffrst_sc2_,
                  sc_core::sc_signal<bool	 >& reset_,
                  sc_core::sc_signal<bool	 >& unnamedNet1_,
                  sc_core::sc_signal<bool	 >& unnamedNet2_
               ) :
                  i_and2_reduced_sc(*i_and2_reduced_sc_),
                  i_const_src_sc1(*i_const_src_sc1_),
                  i_const_src_sc2(*i_const_src_sc2_),
                  i_dffrst_sc1(*i_dffrst_sc1_),
                  i_dffrst_sc2(*i_dffrst_sc2_),
                  reset(reset_),
                  unnamedNet1(unnamedNet1_),
                  unnamedNet2(unnamedNet2_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_and2_reduced_sc;
        delete &i_const_src_sc1;
        delete &i_const_src_sc2;
        delete &i_dffrst_sc1;
        delete &i_dffrst_sc2;

        /// delete signals
        delete &reset;
        delete &unnamedNet1;
        delete &unnamedNet2;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void psd::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sc_core::sc_signal<bool	 >& reset(* new sc_core::sc_signal<bool	 >("reset"));
    sc_core::sc_signal<bool	 >& unnamedNet1(* new sc_core::sc_signal<bool	 >("unnamedNet1"));
    sc_core::sc_signal<bool	 >& unnamedNet2(* new sc_core::sc_signal<bool	 >("unnamedNet2"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    and2_reduced_sc<bool, bool> *i_and2_reduced_sc;
    i_and2_reduced_sc = new and2_reduced_sc<bool, bool>("i_and2_reduced_sc");
    // port binding see netlist section

    const_src_sc<bool> *i_const_src_sc1;
    i_const_src_sc1 = new const_src_sc<bool>("i_const_src_sc1", true);
    // port binding see netlist section

    const_src_sc<bool> *i_const_src_sc2;
    i_const_src_sc2 = new const_src_sc<bool>("i_const_src_sc2", true);
    // port binding see netlist section

    dffrst_sc<bool> *i_dffrst_sc1;
    i_dffrst_sc1 = new dffrst_sc<bool>("i_dffrst_sc1", false, true);
    // port binding see netlist section

    dffrst_sc<bool> *i_dffrst_sc2;
    i_dffrst_sc2 = new dffrst_sc<bool>("i_dffrst_sc2", false, true);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_and2_reduced_sc (and2_reduced_sc<bool, bool>)
    i_and2_reduced_sc -> sc0_i(up);
    i_and2_reduced_sc -> sc1_i(dn);
    i_and2_reduced_sc -> sc_o(reset);

    // i_const_src_sc1 (const_src_sc<bool>)
    i_const_src_sc1 -> sc_o(unnamedNet2);

    // i_const_src_sc2 (const_src_sc<bool>)
    i_const_src_sc2 -> sc_o(unnamedNet1);

    // i_dffrst_sc1 (dffrst_sc<bool>)
    i_dffrst_sc1 -> clk_i(clk_ref);
    i_dffrst_sc1 -> d_i(unnamedNet2);
    i_dffrst_sc1 -> q_o(up);
    i_dffrst_sc1 -> rst_i(reset);

    // i_dffrst_sc2 (dffrst_sc<bool>)
    i_dffrst_sc2 -> clk_i(clk_div);
    i_dffrst_sc2 -> d_i(unnamedNet1);
    i_dffrst_sc2 -> q_o(dn);
    i_dffrst_sc2 -> rst_i(reset);




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_and2_reduced_sc,
                         i_const_src_sc1,
                         i_const_src_sc2,
                         i_dffrst_sc1,
                         i_dffrst_sc2,
                         reset,
                         unnamedNet1,
                         unnamedNet2
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
psd::psd(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          clk_div("clk_div"),
          clk_ref("clk_ref"),
          dn("dn"),
          up("up"),
          p(pa)
{

    architecture();
}

/// destructor implementation
psd::~psd()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


