/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "psd_tb.scaml")
 *  ============================================================================
 */

/// include submodules
#include "psd.h"
#include <sca_basic_libraries/sources_sc/std_clock_sc.h>


#ifndef PLL_LIBPLL_PSD_TB_H_
/// if this file is not included by the header keep implementation
#include "psd_tb.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct psd_tb::components
{

    /// declare instance references for external access
    psd& i_psd;	/** PFD implementation */
    std_clock_sc& i_std_clock_sc1;	/** clock source */
    std_clock_sc& i_std_clock_sc2;	/** clock source */

    /// declare node and signal references for external access
    sc_core::sc_signal<bool	 >& dn;
    sc_core::sc_signal<bool	 >& up;

    /// component constructor
    components(
                  psd* i_psd_,
                  std_clock_sc* i_std_clock_sc1_,
                  std_clock_sc* i_std_clock_sc2_,
                  sc_core::sc_signal<bool	 >& dn_,
                  sc_core::sc_signal<bool	 >& up_
               ) :
                  i_psd(*i_psd_),
                  i_std_clock_sc1(*i_std_clock_sc1_),
                  i_std_clock_sc2(*i_std_clock_sc2_),
                  dn(dn_),
                  up(up_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_psd;
        delete &i_std_clock_sc1;
        delete &i_std_clock_sc2;

        /// delete signals
        delete &dn;
        delete &up;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void psd_tb::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sc_core::sc_signal<bool	 >& dn(* new sc_core::sc_signal<bool	 >("dn"));
    sc_core::sc_signal<bool	 >& up(* new sc_core::sc_signal<bool	 >("up"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    psd::params p_i_psd;
    psd *i_psd;
    i_psd = new psd("i_psd", p_i_psd);
    // port binding see netlist section

    std_clock_sc::params p_i_std_clock_sc1;
    p_i_std_clock_sc1.period = sca_time(p.ref_clk_period, SC_SEC);
    p_i_std_clock_sc1.duty_cycle = 0.5;
    p_i_std_clock_sc1.start_time = sc_core::SC_ZERO_TIME;
    p_i_std_clock_sc1.posedge_first = true;
    std_clock_sc *i_std_clock_sc1;
    i_std_clock_sc1 = new std_clock_sc("i_std_clock_sc1", p_i_std_clock_sc1);
    // port binding see netlist section

    std_clock_sc::params p_i_std_clock_sc2;
    p_i_std_clock_sc2.period = sca_time(p.div_clk_period, SC_SEC);
    p_i_std_clock_sc2.duty_cycle = 0.5;
    p_i_std_clock_sc2.start_time = sc_core::SC_ZERO_TIME;
    p_i_std_clock_sc2.posedge_first = true;
    std_clock_sc *i_std_clock_sc2;
    i_std_clock_sc2 = new std_clock_sc("i_std_clock_sc2", p_i_std_clock_sc2);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_psd (psd)
    i_psd -> clk_div(i_std_clock_sc2->clk_o);
    i_psd -> clk_ref(i_std_clock_sc1->clk_o);
    i_psd -> dn(dn);
    i_psd -> up(up);

    // i_std_clock_sc1 (std_clock_sc)

    // i_std_clock_sc2 (std_clock_sc)




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_psd,
                         i_std_clock_sc1,
                         i_std_clock_sc2,
                         dn,
                         up
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
psd_tb::psd_tb(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          p(pa)
{

    architecture();
}

/// destructor implementation
psd_tb::~psd_tb()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


