/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "top.scaml")
 *  ============================================================================
 */

/// include submodules
#include <sca_basic_libraries/configuration_utilities/param_reader_module.h>
#include "cp.h"
#include "div.h"
#include "lfilter.h"
#include "psd.h"
#include <sca_basic_libraries/sources_sc/std_clock_sc.h>
#include "vco.h"


#ifndef PLL_LIBPLL_TOP_H_
/// if this file is not included by the header keep implementation
#include "top.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct top::components
{

    /// declare instance references for external access
    param_reader_module& i_param_reader_module;	/** parameter reader for schematic usage */
    cp& i_cp;	/** Charge pump implementation */
    div& i_div;	/** Frequency divider */
    lfilter& i_lfilter;	/** Loop filter */
    psd& i_psd;	/** PFD implementation */
    std_clock_sc& i_std_clock_sc;	/** clock source */
    vco& i_vco;	/** Voltage controlled oscillator implementation */

    /// declare node and signal references for external access
    sc_core::sc_signal<bool	 >& dn;
    sc_core::sc_signal<bool	 >& fdiv;
    sca_tdf::sca_signal<double	 >& fout;
    sca_tdf::sca_signal<double	 >& fout_freq;
    sca_tdf::sca_signal<double	 >& icp;
    sc_core::sc_signal<bool	 >& up;
    sca_tdf::sca_signal<double	 >& vcp;
    sca_tdf::sca_signal<double	 >& vctrl;

    /// component constructor
    components(
                  param_reader_module* i_param_reader_module_,
                  cp* i_cp_,
                  div* i_div_,
                  lfilter* i_lfilter_,
                  psd* i_psd_,
                  std_clock_sc* i_std_clock_sc_,
                  vco* i_vco_,
                  sc_core::sc_signal<bool	 >& dn_,
                  sc_core::sc_signal<bool	 >& fdiv_,
                  sca_tdf::sca_signal<double	 >& fout_,
                  sca_tdf::sca_signal<double	 >& fout_freq_,
                  sca_tdf::sca_signal<double	 >& icp_,
                  sc_core::sc_signal<bool	 >& up_,
                  sca_tdf::sca_signal<double	 >& vcp_,
                  sca_tdf::sca_signal<double	 >& vctrl_
               ) :
                  i_param_reader_module(*i_param_reader_module_),
                  i_cp(*i_cp_),
                  i_div(*i_div_),
                  i_lfilter(*i_lfilter_),
                  i_psd(*i_psd_),
                  i_std_clock_sc(*i_std_clock_sc_),
                  i_vco(*i_vco_),
                  dn(dn_),
                  fdiv(fdiv_),
                  fout(fout_),
                  fout_freq(fout_freq_),
                  icp(icp_),
                  up(up_),
                  vcp(vcp_),
                  vctrl(vctrl_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_param_reader_module;
        delete &i_cp;
        delete &i_div;
        delete &i_lfilter;
        delete &i_psd;
        delete &i_std_clock_sc;
        delete &i_vco;

        /// delete signals
        delete &dn;
        delete &fdiv;
        delete &fout;
        delete &fout_freq;
        delete &icp;
        delete &up;
        delete &vcp;
        delete &vctrl;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void top::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sc_core::sc_signal<bool	 >& dn(* new sc_core::sc_signal<bool	 >("dn"));
    sc_core::sc_signal<bool	 >& fdiv(* new sc_core::sc_signal<bool	 >("fdiv"));
    sca_tdf::sca_signal<double	 >& fout(* new sca_tdf::sca_signal<double	 >("fout"));
    sca_tdf::sca_signal<double	 >& fout_freq(* new sca_tdf::sca_signal<double	 >("fout_freq"));
    sca_tdf::sca_signal<double	 >& icp(* new sca_tdf::sca_signal<double	 >("icp"));
    sc_core::sc_signal<bool	 >& up(* new sc_core::sc_signal<bool	 >("up"));
    sca_tdf::sca_signal<double	 >& vcp(* new sca_tdf::sca_signal<double	 >("vcp"));
    sca_tdf::sca_signal<double	 >& vctrl(* new sca_tdf::sca_signal<double	 >("vctrl"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    param_reader_module::params p_i_param_reader_module;
    p_i_param_reader_module.fname = p.par_file;
    p_i_param_reader_module.print = true;
    p_i_param_reader_module.reader_shell = NULL;
    param_reader_module *i_param_reader_module;
    i_param_reader_module = new param_reader_module("i_param_reader_module", p_i_param_reader_module);
    // port binding see netlist section

    cp::params p_i_cp;
    p_i_cp.ts = GET_PARAMETER(double, "tstep");
    p_i_cp.vdd = GET_PARAMETER(double, "vdd");
    p_i_cp.current_up = GET_PARAMETER(double, "current_up");
    p_i_cp.current_dn = GET_PARAMETER(double, "current_dn");
    p_i_cp.current_leak = GET_PARAMETER(double, "current_leak");
    p_i_cp.mosfet_vth = GET_PARAMETER(double, "mosfet_vth");
    cp *i_cp;
    i_cp = new cp("i_cp", p_i_cp);
    // port binding see netlist section

    div::params p_i_div;
    p_i_div.n = GET_PARAMETER(double, "n");
    p_i_div.vcm = GET_PARAMETER(double, "vcm");
    div *i_div;
    i_div = new div("i_div", p_i_div);
    // port binding see netlist section

    lfilter::params p_i_lfilter;
    p_i_lfilter.c1 = GET_PARAMETER(double, "c1");
    p_i_lfilter.r2 = GET_PARAMETER(double, "r2");
    p_i_lfilter.c2 = GET_PARAMETER(double, "c2");
    p_i_lfilter.r3 = GET_PARAMETER(double, "r3");
    p_i_lfilter.c3 = GET_PARAMETER(double, "c3");
    p_i_lfilter.third_order = GET_PARAMETER(bool, "third_order");
    lfilter *i_lfilter;
    i_lfilter = new lfilter("i_lfilter", p_i_lfilter);
    // port binding see netlist section

    psd::params p_i_psd;
    psd *i_psd;
    i_psd = new psd("i_psd", p_i_psd);
    // port binding see netlist section

    std_clock_sc::params p_i_std_clock_sc;
    p_i_std_clock_sc.period = sca_time(GET_PARAMETER(double, "fref_period"), SC_SEC);
    p_i_std_clock_sc.duty_cycle = 0.5;
    p_i_std_clock_sc.start_time = sca_time(GET_PARAMETER(double, "fref_delay"), SC_SEC);
    p_i_std_clock_sc.posedge_first = true;
    std_clock_sc *i_std_clock_sc;
    i_std_clock_sc = new std_clock_sc("i_std_clock_sc", p_i_std_clock_sc);
    // port binding see netlist section

    vco::params p_i_vco;
    p_i_vco.tstep = GET_PARAMETER(double, "tstep");
    p_i_vco.vdd = GET_PARAMETER(double, "vdd");
    p_i_vco.vcm = GET_PARAMETER(double, "vcm");
    p_i_vco.kvo = GET_PARAMETER(double, "kvo");
    p_i_vco.fmin = GET_PARAMETER(double, "fmin");
    vco *i_vco;
    i_vco = new vco("i_vco", p_i_vco);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_param_reader_module (param_reader_module)

    // i_cp (cp)
    i_cp -> dn(dn);
    i_cp -> icp(icp);
    i_cp -> up(up);
    i_cp -> vcp(vcp);

    // i_div (div)
    i_div -> fin(fout);
    i_div -> fout(fdiv);

    // i_lfilter (lfilter)
    i_lfilter -> icp(icp);
    i_lfilter -> vcp(vcp);
    i_lfilter -> vctrl(vctrl);

    // i_psd (psd)
    i_psd -> clk_div(fdiv);
    i_psd -> clk_ref(i_std_clock_sc->clk_o);
    i_psd -> dn(dn);
    i_psd -> up(up);

    // i_std_clock_sc (std_clock_sc)

    // i_vco (vco)
    i_vco -> fout(fout);
    i_vco -> freq(fout_freq);
    i_vco -> vctrl(vctrl);




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_param_reader_module,
                         i_cp,
                         i_div,
                         i_lfilter,
                         i_psd,
                         i_std_clock_sc,
                         i_vco,
                         dn,
                         fdiv,
                         fout,
                         fout_freq,
                         icp,
                         up,
                         vcp,
                         vctrl
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
top::top(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          p(pa)
{

    architecture();
}

/// destructor implementation
top::~top()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


