////////////////////////////////////////////////////////////////////////////////
//
// @copyright COSEDA Technologies GmbH. All rights reserved.
//            (customizable in sca_modules.dtd)
//
////////////////////////////////////////////////////////////////////////////////
//
// TESTBENCH FOR MODULE: top
//
// DESCRIPTION:
//
//
// this file was generated by 'sca_xml2simple_tb.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
//   Version Id       : $Id$
//   Author           : Américo Dias
//   Last Modified By : $Author$
//   Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

// enable to access module components within the hierarchy
// #define ACCESS_MODULE_COMPONENTS_HIERARCHIC

#include <systemc.h>
#include <systemc-ams.h>
#include "../libpll/top.h"

// include COSIDE test bench utilities
#include "sca_basic_libraries/coside_utilities.h"
#include "sca_basic_libraries/coside_libraries.h"
#include <sca_basic_libraries/configuration_utilities/param_reader_module.h>

#include <cstdlib>

int sc_main(int argc, char* argv[])
{
    sc_core::sc_set_time_resolution(1.0, sc_core::SC_FS);

    //display current simulation time
    //sim_ctrl show_sim_time("show_sim_time", sc_core::sc_time(0.1, sc_core::SC_MS));

    //////////////////////////////////////////////////////////////////////////////
    // define DUT parameter structure                                           //
    //////////////////////////////////////////////////////////////////////////////

    top::params p_top;
    p_top.par_file = "top.par";  /* ??? */

    //////////////////////////////////////////////////////////////////////////////
    // command line reader                                                      //
    // default options:                                                         //
    //                  --help              - list all parameter and usage      //
    //                  --sim_time=5.0e-3   - start testbench (default: 5ms)    //
    //////////////////////////////////////////////////////////////////////////////

    cmd_line_reader::config c_coside_clr;
    c_coside_clr.verbose = true;
    cmd_line_reader* i_coside_clr;
    i_coside_clr = new cmd_line_reader(argc, argv, c_coside_clr);
      //i_coside_clr -> add("sim_time", sim_time, "simulation time in seconds (default: 5ms)");
      i_coside_clr -> add("par_file", p_top.par_file, "File containing the simulation parameters.");
      i_coside_clr -> read();

	/////////////////////////////////////////////////////////////////////////
	// Get simulation time from Parameter Reader                           //
	/////////////////////////////////////////////////////////////////////////
	param_reader_module::params p_i_param_reader_module1;
	p_i_param_reader_module1.fname = p_top.par_file;
	p_i_param_reader_module1.print = false;
	param_reader_module *i_param_reader_module1;
	i_param_reader_module1 = new param_reader_module("i_param_reader_module1", p_i_param_reader_module1);
	double sim_time = GET_PARAMETER(double, "tsim");
	delete i_param_reader_module1;
    //////////////////////////////////////////////////////////////////////////////
    // signal definition                                                        //
    //////////////////////////////////////////////////////////////////////////////


    //////////////////////////////////////////////////////////////////////////////
    // DUT - device under test                                                  //
    //////////////////////////////////////////////////////////////////////////////

    top* i_top;
    i_top = new top("i_top", p_top);

    //////////////////////////////////////////////////////////////////////////////
    // trace signals using object access utilities - see COSIDE documentation   //
    //////////////////////////////////////////////////////////////////////////////


    sca_util::sca_trace_file *tf = sca_util::sca_create_tabular_trace_file("pll.dat");
      sca_object_trace(tf, "i_top.%");
      sca_object_trace(tf, "i_top.i_psd.clk_ref", "i_top.fref");

    //////////////////////////////////////////////////////////////////////////////
    // time domain simulation                                                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_start(sim_time, sc_core::SC_SEC);

    SC_REPORT_INFO("sc_main", "time domain simulation complete");

    SC_REPORT_INFO("sc_main", "\n"
      "//////////////////////////////////////////////////////////////////////////////\n"
      "//                            Simulation finished                           //\n"
      "//////////////////////////////////////////////////////////////////////////////");

    sc_core::sc_stop();
    SC_REPORT_INFO("sc_main", ("simulation stopped at " + sc_core::sc_time_stamp().to_string()).c_str());

    sca_util::sca_close_tabular_trace_file(tf);

    // clean-up
    delete i_top;
    delete i_coside_clr;

    return EXIT_SUCCESS;
}
