/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "vco_tb.scaml")
 *  ============================================================================
 */

/// include submodules
#include <sca_basic_libraries/sources_tdf/pwl_src_tdf.h>
#include "vco.h"


#ifndef PLL_LIBPLL_VCO_TB_H_
/// if this file is not included by the header keep implementation
#include "vco_tb.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct vco_tb::components
{

    /// declare instance references for external access
    pwl_src_tdf& i_pwl_src_tdf;	/** piece wise linear source */
    vco& i_vco;	/** Voltage controlled oscillator implementation */

    /// declare node and signal references for external access
    sca_tdf::sca_signal<double	 >& fout;
    sca_tdf::sca_signal<double	 >& freq;
    sca_tdf::sca_signal<double	 >& vctrl;

    /// component constructor
    components(
                  pwl_src_tdf* i_pwl_src_tdf_,
                  vco* i_vco_,
                  sca_tdf::sca_signal<double	 >& fout_,
                  sca_tdf::sca_signal<double	 >& freq_,
                  sca_tdf::sca_signal<double	 >& vctrl_
               ) :
                  i_pwl_src_tdf(*i_pwl_src_tdf_),
                  i_vco(*i_vco_),
                  fout(fout_),
                  freq(freq_),
                  vctrl(vctrl_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_pwl_src_tdf;
        delete &i_vco;

        /// delete signals
        delete &fout;
        delete &freq;
        delete &vctrl;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void vco_tb::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sca_tdf::sca_signal<double	 >& fout(* new sca_tdf::sca_signal<double	 >("fout"));
    sca_tdf::sca_signal<double	 >& freq(* new sca_tdf::sca_signal<double	 >("freq"));
    sca_tdf::sca_signal<double	 >& vctrl(* new sca_tdf::sca_signal<double	 >("vctrl"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    pwl_src_tdf::params p_i_pwl_src_tdf;
    p_i_pwl_src_tdf.pwl_curve = {{0_SC_SEC,0.0}, {1_SC_MS,1.0} , {2_SC_MS,0.0}};
    p_i_pwl_src_tdf.wave = sca_util::sca_create_vector(0.0, 0.0, p.tstop, p.vdd);
    p_i_pwl_src_tdf.repeat = false;
    p_i_pwl_src_tdf.sampling_time = sc_core::SC_ZERO_TIME;
    pwl_src_tdf *i_pwl_src_tdf;
    i_pwl_src_tdf = new pwl_src_tdf("i_pwl_src_tdf", p_i_pwl_src_tdf);
    // port binding see netlist section

    vco::params p_i_vco;
    p_i_vco.tstep = 1.0/(10.0*p.fmin);
    p_i_vco.vdd = p.vdd;
    p_i_vco.vcm = p.vdd/2.0;
    p_i_vco.kvo = p.kvo;
    p_i_vco.fmin = p.fmin;
    vco *i_vco;
    i_vco = new vco("i_vco", p_i_vco);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_pwl_src_tdf (pwl_src_tdf)
    i_pwl_src_tdf -> tdf_o(vctrl);

    // i_vco (vco)
    i_vco -> fout(fout);
    i_vco -> freq(freq);
    i_vco -> vctrl(vctrl);




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_pwl_src_tdf,
                         i_vco,
                         fout,
                         freq,
                         vctrl
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
vco_tb::vco_tb(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          p(pa)
{

    architecture();
}

/// destructor implementation
vco_tb::~vco_tb()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


