////////////////////////////////////////////////////////////////////////////////
//
// @copyright COSEDA Technologies GmbH. All rights reserved.
//            (customizable in sca_modules.dtd)
//
////////////////////////////////////////////////////////////////////////////////
//
// this file was generated by 'sca_xml2scsimctrl_tb.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
//   Version Id       : $Id$
//   Author           : SCSimCtrl
//   Last Modified By : $Author$
//   Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic/primitive.
 *  = (recreate via: "vco_tb.scaml")
 *  ============================================================================
 */

// enable to access module components within the hierarchy
// #define ACCESS_MODULE_COMPONENTS_HIERARCHIC

#include <systemc.h>
#include <systemc-ams.h>
#include "../libpll/vco_tb.h"

// include COSIDE test bench utilities
#include "sca_basic_libraries/coside_utilities.h"
#include "sca_basic_libraries/coside_libraries.h"

#include <cstdlib>

int sc_main(int argc, char* argv[])
{
    sc_core::sc_set_time_resolution(1.0, sc_core::SC_FS);

    //////////////////////////////////////////////////////////////////////////////
    // define DUT parameter structure                                           //
    //////////////////////////////////////////////////////////////////////////////

    vco_tb::params p_vco_tb;
    p_vco_tb.vdd = 3.3;  /* Voltage supply */
    p_vco_tb.kvo = 36.363636e6;  /* VCO gain */
    p_vco_tb.fmin = 2.39e9;  /* Minimum frequency */
    p_vco_tb.tstep = 40e-12;  /* ??? */
    p_vco_tb.tstop = 200e-9;  /* ??? */

    //////////////////////////////////////////////////////////////////////////////
    // command line reader                                                      //
    // default options:                                                         //
    //                  --help              - list all parameter and usage      //
    //                  --sim_time          - start testbench                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_time sim_time = sc_core::sc_max_time();
    
    cmd_line_reader::config c_coside_clr;
    c_coside_clr.verbose = true;
    cmd_line_reader* i_coside_clr;
    i_coside_clr = new cmd_line_reader(argc, argv, c_coside_clr);
      i_coside_clr -> add("sim_time", sim_time, "simulation time in seconds");
      i_coside_clr -> add("vdd", p_vco_tb.vdd, "Voltage supply");
      i_coside_clr -> add("kvo", p_vco_tb.kvo, "VCO gain");
      i_coside_clr -> add("fmin", p_vco_tb.fmin, "Minimum frequency");
      i_coside_clr -> add("tstep", p_vco_tb.tstep, "???");
      i_coside_clr -> add("tstop", p_vco_tb.tstop, "???");
      i_coside_clr -> read();

    //////////////////////////////////////////////////////////////////////////////
    // signal definition                                                        //
    //////////////////////////////////////////////////////////////////////////////


    //////////////////////////////////////////////////////////////////////////////
    // DUT - device under test                                                  //
    //////////////////////////////////////////////////////////////////////////////

    vco_tb* i_vco_tb;
    i_vco_tb = new vco_tb("i_vco_tb", p_vco_tb);

    //////////////////////////////////////////////////////////////////////////////
    // time domain simulation                                                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_start(sim_time-sc_core::sc_time_stamp(), sc_core::SC_EXIT_ON_STARVATION);

    SC_REPORT_INFO("sc_main", "time domain simulation complete");

    SC_REPORT_INFO("sc_main", "\n"
      "//////////////////////////////////////////////////////////////////////////////\n"
      "//                            Simulation finished                           //\n"
      "//////////////////////////////////////////////////////////////////////////////");

    SC_REPORT_INFO("sc_main", ("simulation stopped at " + sc_core::sc_time_stamp().to_string()).c_str());

    // clean-up
    delete i_vco_tb;
    delete i_coside_clr;

    return EXIT_SUCCESS;
}
